part of masamune.dartcore;

/// Extends the Iterable class.
extension IterableExtension<T extends Object> on Iterable<T> {
  /// Method indexed forEach
  /// The [index] starts at 0 and is incremented by 1
  /// 
  /// [function]: Action to be performed
  void forEachIndex( void function( T value, int index ) ){
    int i = 0;
    for( T value in this ){
      function( value, i );
      i++;
    }
  }
}
